/*
Dot and Box MinMax JbgvO@V1.10@Y.Hoshino
2003.5.26
*/

#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <string.h>

#define OK 1
#define NG 0
#define ACTION 1
#define PASS   0
#define ME  0
#define YOU 1
#define FINISH      1
#define NOT_FINISH  0
#define MAX_SC    9999
#define MIN_SC   -9999

/*N()xM(c)TCỸtB[hpӂDep[^́C3ȏ̊*/
#define N 9 /*  Dot:5 '-'Blank:4 */
#define M 9 /* c Dot:5 '|'Blank:4 */

#define DEEPSIZE (4) 
#define MAXDEEP (N-1)/2*(M+1)/2+(N+1)/2*(M-1)/2 /*ő[xvZ(\Ȑ̐)*/
#define MXBX ((M-1)*(N-1)/4)/*ő唠̐*/
#define REFRESH (500)

char Current[M][N];/*݂̋ǖ*/
char TreeStack[MAXDEEP][M][N];/*ǂݖ؂̋ǖ*/
int randlistN[MAXDEEP][N],randlistM[MAXDEEP][M];/*x,y̗Xg*/
int deep_num,line_num,youbox,mybox;

#define PrntCrentDotBx()  PrintDotBx(Current)

int TreeMin(int,int,int,int),TreeMax(int,int,int,int);

void CountBox(){
	int x,y;
	mybox=0;youbox=0;line_num=0;
	for(y=0;y<M;y++)
		for(x=0;x<N;x++){
			mybox += (Current[y][x]==6);
			youbox += (Current[y][x]==7);
			line_num += (Current[y][x]==1) + (Current[y][x]==2);
		}
}

/*--- Win Lose ---*/
void ResultOut(int _win,int _lose,int _draw){
	FILE *fp;

	if( (fp  = fopen( "result.txt", "w" )) == NULL ){
      printf( "t@C result.txt ͊J܂łB\n" );
	  return;
	}
	fprintf(fp,"Win:%d Lose:%d Draw:%d\n",_win,_lose,_draw);
    fclose(fp);
    
    if( (fp  = fopen( "hist.csv", "a+" )) == NULL ){
      printf( "t@C hist.txt ͊J܂łB\n" );
      if( (fp  = fopen( "hist.csv", "w" )) == NULL ) return;
      fprintf(fp,"Win,Lose,Draw,\n");
	}
	fprintf(fp,"%d,%d,%d,\n",_win,_lose,_draw);
    fclose(fp);
}

/*Q[C^tF[X*/
void PrintDotBx(char View[M][N]){
	int xx,yy;

	printf("\r  ");
	for(xx=0;xx<N;xx++){
		printf("%d",xx);
	}
	printf("\n-------------\n");
	for(yy=0;yy<M;yy++){
		printf("%d|",yy);
		for(xx=0;xx<N;xx++){
			switch(View[yy][xx]){
			case 0: printf("o"); break;
			case 1: printf(":"); break;/*Debug*//*case 1: printf(" "); break;*/
			case 2: printf("."); break;/*Debug*//*case 2: printf(" "); break;*/
			case 3: printf("|"); break;
			case 4: printf("-"); break;
			case 5: printf(" "); break;
			case 6: printf("M"); break;
			case 7: printf("Y"); break;
			}
		}
		printf("\n");
	}
	printf("\n");
}

void CreateInitMap(){
	int xx,yy,xevn,yevn;

	youbox=0;mybox=0;
	for(yy=0,yevn=1;yy<M;yy++,yevn=(yevn==0)){
		for(xx=0,xevn=1;xx<N;xx++,xevn=(xevn==0)){
			if( xevn &&  yevn) Current[yy][xx] = 0;			
			if( xevn && !yevn) Current[yy][xx] = 1;
			if(!xevn &&  yevn) Current[yy][xx] = 2;
			if(!xevn && !yevn) Current[yy][xx] = 5;
		}
	}
}

int EnableDoIt(int xx,int yy){
	if(Current[yy][xx] == 1) return OK;
	if(Current[yy][xx] == 2) return OK;
	return NG;
}

int HumanAct(int *actx,int *acty){
	int xx,yy,x,y,sx,sy;

	for(;;){
		printf("X[0,1-%d]? ",N); scanf("%d",&x);
		printf("Y[0,1-%d]? ",M); scanf("%d",&y);
		if(x==0 && y==0) break;
		if(x>N || y>M) continue;
		if(EnableDoIt(x,y)==OK){
			*actx = x; *acty = y;return ACTION;
		}
	}
	return PASS;
}

int RandAction(int *actx,int *acty){
	int xx,yy,x,y,num;
	num=(rand()%MAXDEEP);
	for(xx=0;xx<N;xx++){
		x = randlistN[num][xx];
		for(yy=0;yy<M;yy++){
			y = randlistM[num][yy];
			if(EnableDoIt(x,y)==OK){
				*actx = x; *acty = y;return ACTION;
			}
		}
	}
	return PASS;
}

int Do_it(int turn,int xx,int yy){
	int x,y;
	line_num = 0;
	if(EnableDoIt(xx,yy)==OK){
		if(Current[yy][xx]==1){/*c*/
			Current[yy][xx]=3;
			if(xx>1 && Current[yy][xx-1]==5 && Current[yy][xx-2]==3
				&& Current[yy-1][xx-1]==4 && Current[yy+1][xx-1]==4){
				if(turn == ME ){Current[yy][xx-1]=6;}
				if(turn == YOU){Current[yy][xx-1]=7;}
			}
			if(xx<(N-1) && Current[yy][xx+1]==5 && Current[yy][xx+2]==3
				&& Current[yy-1][xx+1]==4 && Current[yy+1][xx+1]==4){
				if(turn == ME ){Current[yy][xx+1]=6;}
				if(turn == YOU){Current[yy][xx+1]=7;}
			}	
		}
		if(Current[yy][xx]==2){/**/
			Current[yy][xx]=4;
			if(yy>1 && Current[yy-1][xx]==5 && Current[yy-2][xx]==4
				&& Current[yy-1][xx-1]==3 && Current[yy-1][xx+1]==3){
				if(turn == ME ){Current[yy-1][xx]=6;}
				if(turn == YOU){Current[yy-1][xx]=7;}
			}
			if(yy<(M-1) && Current[yy+1][xx]==5 && Current[yy+2][xx]==4
				&& Current[yy+1][xx-1]==3 && Current[yy+1][xx+1]==3){
				if(turn == ME ){Current[yy+1][xx]=6;}
				if(turn == YOU){Current[yy+1][xx]=7;}
			}
		}
	}
	CountBox();/*myboxyouboxvZ*/
	if((mybox+youbox)>=MXBX) return FINISH;
	return NOT_FINISH;
}

int TreeMax(int num,int alpha,int beta,int move){
	int xx,yy,x,y,sc,flg,gohash,box_num;
	int treemax;

	if (num==deep_num) return (mybox-youbox);

	memcpy((void*)&TreeStack[num][0][0],(void*)&Current[0][0],sizeof(Current));
	box_num = mybox;
	flg = 0;
	treemax = alpha;
	for(xx=0;xx<N;xx++){
		x = randlistN[num][xx];
		for(yy=0;yy<M;yy++){
			y = randlistM[num][yy];
			if(EnableDoIt(x,y)==OK){
				flg = 1;
				if(Do_it(ME,x,y)==FINISH) sc = (mybox-youbox);/*Q[I*/
				else{
					if(box_num==mybox)
						sc = TreeMin(num+1,alpha,beta,move+1);
					else
						sc = TreeMax(num+1,alpha,beta,move+1);
				}
				treemax = (int)(sc>treemax)?sc:treemax;
				alpha = (int)(treemax); 
				/*OMinŏlI邽߁C
					}̕]l傫l̍őlԂĂMinō̗pȂD*/
				if(alpha>beta){/*printf("[a-cut]");*/return alpha;}
				memcpy((void*)&Current[0][0],(void*)&TreeStack[num][0][0],sizeof(Current));
			}
		}
	}
	if(flg == 0) return (mybox-youbox);
	return treemax;
}

int TreeMin(int num,int alpha,int beta,int move){
	int xx,yy,x,y,sc,flg,gohash,box_num;
	int treemin;

	if (num==deep_num) return (mybox-youbox);
	box_num = youbox;
	memcpy((void*)&TreeStack[num][0][0],(void*)&Current[0][0],sizeof(Current));

	flg = 0;
	treemin=beta;

	for(xx=0;xx<N;xx++){
		x = randlistN[num][xx];
		for(yy=0;yy<M;yy++){
			y = randlistM[num][yy];
			if(EnableDoIt(x,y)==OK){
				flg = 1;
				if(Do_it(YOU,x,y)==FINISH) sc = (mybox-youbox);/*Q[I*/
				else{
					if(box_num==youbox)
						sc = TreeMax(num+1,alpha,beta,move+1);
					else
						sc = TreeMin(num+1,alpha,beta,move+1);
				}
				treemin = (int)(sc<treemin)?sc:treemin;
				beta = (int)(treemin);
				/*OMaxőlI邽߁C
					}̕]l菬l̍ŏlԂĂMaxō̗pȂD*/
				if(alpha>beta){/*printf("[b-cut]");*/return beta;}
				memcpy((void*)&Current[0][0],(void*)&TreeStack[num][0][0],sizeof(Current));
			}
		}
	}
	if (flg==0) return (mybox-youbox);
	return treemin;
}
int DEEP_CUL(){
	int deep_num,box_num;
	box_num = (mybox+youbox);/*Ă锠̐*/
	deep_num = (DEEPSIZE>box_num)?DEEPSIZE:box_num;/*ݒ[蔠Ȃꍇ ̐[ǂ*/
	deep_num = (deep_num<line_num)?deep_num:line_num;/*{ŐDTm[h=!line_num*/
	return deep_num;
}
int PickUpMax(int *actx,int *acty,int move){
	int num,xx,yy,x,y;int sc,maxsc,jj,gohash,box_num;
	num = 0;
	memcpy((void*)&TreeStack[num][0][0],(void*)&Current[0][0],sizeof(Current));
	maxsc = MIN_SC;
	radlistShake();
	jj = M*N;

	/*[x line_num={@MXBX=ő{*/
	deep_num = DEEP_CUL();
	/*printf("[%d]\n",deep_num);*/
	box_num = mybox;
	for(xx=0;xx<N;xx++){
		x = randlistN[num][xx];
		for(yy=0;yy<M;yy++){
			y = randlistM[num][yy];
			if(EnableDoIt(x,y)==OK){
				if(Do_it(ME,x,y)==FINISH) sc = (mybox-youbox);/*Q[I*/
				else{ 
					if(box_num==mybox)
						sc = TreeMin(num+1,maxsc,MAX_SC,move+1);/*TJn*/
					else
						sc = TreeMax(num+1,maxsc,MAX_SC,move+1);/*TJn*/
				}
				if(sc > maxsc){
					maxsc = sc;
					*actx=x;
					*acty=y;
				}
				/*printf("\rx:%d y:%d e:%d\n",x,y,sc);*/
			}
			printf("\r %d[%%]  ",(int)((jj*100)/(M*N)));jj--;
			memcpy((void*)&Current[0][0],(void*)&TreeStack[num][0][0],sizeof(Current));
		}
	}
	if(maxsc > -99999) return ACTION;
	return PASS;

}
int radlistInit(){
	int i,h;
	for(h=0;h<MAXDEEP;h++){
		for(i=0;i<N;i++) randlistN[h][i] = i;
		for(i=0;i<M;i++) randlistM[h][i] = i;
	}
}
int radlistShake(){
	int h,i,j,k,temp;
	for(h=0;h<MAXDEEP;h++){
		for(i=0;i<3;i++){
			j=(rand()%N);
			k=(rand()%N);
			temp=randlistN[h][k];
			randlistN[h][k] = randlistN[h][j];
			randlistN[h][j] = temp;
		}
		for(i=0;i<3;i++){
			j=(rand()%M);
			k=(rand()%M);
			temp=randlistM[h][k];
			randlistM[h][k] = randlistM[h][j];
			randlistM[h][j] = temp;
		}
	}
}
int keycheck(){
	char cc;
	do{
			printf("One More Try?\n");
			scanf("%c",&cc);
			if(cc=='N'|| cc=='n') return 0;
			if(cc=='Y'|| cc=='y') return 1;
	}while(1);
}
int main(){
	int i,gamet,turn,x,y,ret,_win,_lose,_draw,boxnum;
	char cc;
	srand( (unsigned)time( NULL ) );
	_win=0;_lose=0;_draw=0;
	radlistInit();
	for(gamet=0;;gamet++){
		CreateInitMap();
		PrntCrentDotBx();/*ǖʕ\*/
		for(i=0;i<100;i++){
			do{
				boxnum = youbox;
				turn=YOU;
				/*if(RandAction(&x,&y)==ACTION){*/
				if(HumanAct(&x,&y)==ACTION){
					printf("YOU:%d %d\n",x,y);
					ret=Do_it(turn,x,y);
				}else printf("YOU:Pass\n");
				PrntCrentDotBx();/*ǖʕ\*/
				if(ret==FINISH)break;
			}while(boxnum!=youbox);

			if(ret==FINISH)break;

			do{
				boxnum = mybox;
				turn=ME;/* ME is Comuter */
				/*if(RandAction(&x,&y)==ACTION){*/
				if(PickUpMax(&x,&y,i)==ACTION){
					printf("ME:%d %d\n",x,y);
					ret=Do_it(turn,x,y);
				}else printf("ME :Pass\n");
				PrntCrentDotBx();/*ǖʕ\*/
				if(ret==FINISH)break;
			}while(boxnum!=mybox);

			if(ret==FINISH)break;

		}
		if (youbox > mybox){ printf("You Win!!"); _win++;}
		else if (youbox < mybox){ printf("Computer(MinMax) Win!!"); _lose++;}
		else { printf("Draw !!"); _draw++;};
		printf("\n");
		ResultOut(_win,_lose,_draw);
		if(!keycheck()) break; /*I?*/
	}
	printf("\n");
	return 0;
}

